script_name("AutoTochilki")
script_author("vegas~")

local sampev = require "lib.samp.events"
local imgui = require "imgui"
local encoding = require "encoding"
encoding.default = "CP1251" 
local u8 = encoding.UTF8

local w, h = getScreenResolution()

local settings = {
	state = imgui.ImBool(false),
	value = imgui.ImInt(0),

	needStone = false,
	waitStone = 0,
	multiStone = -1,

	clickTextDraws = {},

	craft = false,
	values = {},
	textDraws = {
		main = {pos = {x = "206.29", y = "179.89"}, id = 2067},
		str = {pos = {x = "171.13", y = "245.14"}, id = 2084},
		craft = {pos = {x = "185.66", y = "258.65"}, id = 2077},
		put = {pos = {x = "231.50", y = "204.71"}, id = 2082},
		inventory = {pos = {x = "383.00", y = "351.24"}, id = 2092},
	},
}

local functions = {
	applyTheme,
	switchState,
	switchStateCraft,
	textQuestion,
	doesStoneExists,
	findStone,
	engineStone,
	rightClickTextDraw,
}

functions.applyTheme = function()
	imgui.SwitchContext()
	local style = imgui.GetStyle()
	local colors = style.Colors
	local clr = imgui.Col
	local ImVec4 = imgui.ImVec4
	
	style.WindowRounding = 2.0
	style.WindowTitleAlign = imgui.ImVec2(0.5, 0.84)
	style.ChildWindowRounding = 2.0
	style.FrameRounding = 2.0
	style.ItemSpacing = imgui.ImVec2(5.0, 4.0)
	style.ScrollbarSize = 13.0
	style.ScrollbarRounding = 0
	style.GrabMinSize = 8.0
	style.GrabRounding = 1.0
	
	colors[clr.Text]                   = ImVec4(1.00, 1.00, 1.00, 1.00)
	colors[clr.TextDisabled]           = ImVec4(0.50, 0.50, 0.50, 1.00)
	colors[clr.WindowBg]               = ImVec4(0.06, 0.06, 0.06, 0.94)
	colors[clr.ChildWindowBg]          = ImVec4(1.00, 1.00, 1.00, 0.00)
	colors[clr.PopupBg]                = ImVec4(0.08, 0.08, 0.08, 0.94)
	colors[clr.ComboBg]                = colors[clr.PopupBg]
	colors[clr.Border]                 = ImVec4(0.43, 0.43, 0.50, 0.50)
	colors[clr.BorderShadow]           = ImVec4(0.00, 0.00, 0.00, 0.00)
	colors[clr.FrameBg]                = ImVec4(0.16, 0.29, 0.48, 0.54)
	colors[clr.FrameBgHovered]         = ImVec4(0.26, 0.59, 0.98, 0.40)
	colors[clr.FrameBgActive]          = ImVec4(0.26, 0.59, 0.98, 0.67)
	colors[clr.TitleBg]                = ImVec4(0.04, 0.04, 0.04, 1.00)
	colors[clr.TitleBgActive]          = ImVec4(0.16, 0.29, 0.48, 1.00)
	colors[clr.TitleBgCollapsed]       = ImVec4(0.00, 0.00, 0.00, 0.51)
	colors[clr.MenuBarBg]              = ImVec4(0.14, 0.14, 0.14, 1.00)
	colors[clr.ScrollbarBg]            = ImVec4(0.02, 0.02, 0.02, 0.53)
	colors[clr.ScrollbarGrab]          = ImVec4(0.31, 0.31, 0.31, 1.00)
	colors[clr.ScrollbarGrabHovered]   = ImVec4(0.41, 0.41, 0.41, 1.00)
	colors[clr.ScrollbarGrabActive]    = ImVec4(0.51, 0.51, 0.51, 1.00)
	colors[clr.CheckMark]              = ImVec4(0.26, 0.59, 0.98, 1.00)
	colors[clr.SliderGrab]             = ImVec4(0.24, 0.52, 0.88, 1.00)
	colors[clr.SliderGrabActive]       = ImVec4(0.26, 0.59, 0.98, 1.00)
	colors[clr.Button]                 = ImVec4(0.26, 0.59, 0.98, 0.40)
	colors[clr.ButtonHovered]          = ImVec4(0.26, 0.59, 0.98, 1.00)
	colors[clr.ButtonActive]           = ImVec4(0.06, 0.53, 0.98, 1.00)
	colors[clr.Header]                 = ImVec4(0.26, 0.59, 0.98, 0.31)
	colors[clr.HeaderHovered]          = ImVec4(0.26, 0.59, 0.98, 0.80)
	colors[clr.HeaderActive]           = ImVec4(0.26, 0.59, 0.98, 1.00)
	colors[clr.Separator]              = colors[clr.Border]
	colors[clr.SeparatorHovered]       = ImVec4(0.26, 0.59, 0.98, 0.78)
	colors[clr.SeparatorActive]        = ImVec4(0.26, 0.59, 0.98, 1.00)
	colors[clr.ResizeGrip]             = ImVec4(0.26, 0.59, 0.98, 0.25)
	colors[clr.ResizeGripHovered]      = ImVec4(0.26, 0.59, 0.98, 0.67)
	colors[clr.ResizeGripActive]       = ImVec4(0.26, 0.59, 0.98, 0.95)
	colors[clr.CloseButton]            = ImVec4(0.41, 0.41, 0.41, 0.50)
	colors[clr.CloseButtonHovered]     = ImVec4(0.98, 0.39, 0.36, 1.00)
	colors[clr.CloseButtonActive]      = ImVec4(0.98, 0.39, 0.36, 1.00)
	colors[clr.PlotLines]              = ImVec4(0.61, 0.61, 0.61, 1.00)
	colors[clr.PlotLinesHovered]       = ImVec4(1.00, 0.43, 0.35, 1.00)
	colors[clr.PlotHistogram]          = ImVec4(0.90, 0.70, 0.00, 1.00)
	colors[clr.PlotHistogramHovered]   = ImVec4(1.00, 0.60, 0.00, 1.00)
	colors[clr.TextSelectedBg]         = ImVec4(0.26, 0.59, 0.98, 0.35)
	colors[clr.ModalWindowDarkening]   = ImVec4(0.80, 0.80, 0.80, 0.35)
end

functions.rightClickTextDraw = function(time, id)
	table.insert(settings.clickTextDraws, {wait = os.clock() + time/1000, id = id})
end

functions.switchState = function()
	settings.state.v = not settings.state.v
end

functions.switchStateCraft = function()
	settings.craft = not settings.craft
	settings.needStone = false
	settings.clickTextDraws = {}

	functions.rightClickTextDraw(0, settings.textDraws.craft.id)
end

functions.textQuestion = function(str)
	if not imgui.IsItemHovered() then
		return
	end

	imgui.BeginTooltip()
	imgui.PushTextWrapPos(450)
	imgui.TextUnformatted(str)
	imgui.PopTextWrapPos()
	imgui.EndTooltip()
end

functions.doesStoneExists = function()
	if sampTextdrawGetString(settings.textDraws.put.id) == "_" then
		settings.needStone = true
		settings.waitStone = 0
		settings.multiStone = -1
		return
	end

	functions.rightClickTextDraw(0, settings.textDraws.craft.id)
end

functions.findStone = function()
	if not settings.craft or not settings.needStone or settings.waitStone > os.clock() then
		return
	end

	settings.waitStone = os.clock() + 2
	settings.multiStone = settings.multiStone < 3 and settings.multiStone + 1 or -1

	if settings.multiStone == -1 then
		functions.switchStateCraft()
		sampAddChatMessage("  !", 0xFF4896BA)
		return
	end

	
	functions.rightClickTextDraw(0, settings.textDraws.inventory.id + settings.multiStone)
end

functions.engineStone = function(id, data)
	local CutX, CutY = ("%.2f"):format(data.position.x), ("%.2f"):format(data.position.y)

	for i, k in pairs(settings.textDraws) do
		if k.pos.x == CutX and k.pos.y == CutY then
			settings.textDraws[i].id = id
			break
		end
	end

	if settings.needStone then
		if data.modelId == 16112 or data.modelId == 1615 then
			settings.needStone = false

			functions.rightClickTextDraw(2000, id)
			functions.rightClickTextDraw(4000, settings.textDraws.craft.id)
		end

		return
	end

	if not settings.craft or id ~= settings.textDraws.main.id or (data.boxColor ~= 1515015679 and data.boxColor ~= 1515913037) then
		return
	end

	local level = tonumber(sampTextdrawGetString(settings.textDraws.str.id):match("(%d+)"))

	if level < settings.value.v + 1 then
		functions.doesStoneExists()
		return
	end
end

function main()
	functions.applyTheme()
	for i = 1, 12 do table.insert(settings.values, u8"+"..i) end

	repeat wait(0) until isSampAvailable()

	sampRegisterChatCommand("toch", functions.switchState)

	while true do wait(0)
		imgui.Process = settings.state.v

		for i = #settings.clickTextDraws, 1, -1 do
			local textDraw = settings.clickTextDraws[i]

			if textDraw.wait < os.clock() then
				sampSendClickTextdraw(textDraw.id)
				table.remove(settings.clickTextDraws, i)
			end
		end

		functions.findStone()
	end
end

function imgui.OnDrawFrame()
	if settings.state.v then
		imgui.SetNextWindowSize(imgui.ImVec2(280, 150), imgui.Cond.FirstUseEver)
		imgui.SetNextWindowPos(imgui.ImVec2(w/2, h/2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5,0.5))
		imgui.Begin("AutoTochilki by vegas~", settings.state, imgui.WindowFlags.NoCollapse + imgui.WindowFlags.NoResize + imgui.WindowFlags.NoScrollbar)
		
		imgui.PushItemWidth(150)

		imgui.SetCursorPos(imgui.ImVec2(280 / 2 - 150 / 2, 40))
		if imgui.Button(not settings.craft and u8" " or u8" ", imgui.ImVec2(150, 20)) then
			functions.switchStateCraft()
		end
		functions.textQuestion(u8"          ", imgui.SameLine())
		
		imgui.SetCursorPos(imgui.ImVec2(280 / 2 - 150 / 2, 65))
		imgui.Combo("##value", settings.value, settings.values)
		functions.textQuestion(u8"     ")

		imgui.SetCursorPos(imgui.ImVec2(280 / 2 - 150 / 2, 90))
		if imgui.Button(u8"  ", imgui.ImVec2(150, 20)) then
			os.execute("explorer https://www.blast.hk/threads/73563/")
		end
		functions.textQuestion(u8"   -  ")

		imgui.End()
	end
end

function sampev.onShowTextDraw(id, data)
	functions.engineStone(id, data)
end